#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#ifdef ITEM
#else
#include "item.h"
#endif
#include "ST.h"

booleano STinicializar (tipo_no **cabeca){
  Item *item;
  printf ("\nTentando inserir ...");
  if ((*cabeca = (tipo_no*) malloc (sizeof(tipo_no) )) == NULL)
  return (false);
  else {
  if ((item = (Item*) malloc (sizeof(Item))) == NULL){
    free (*cabeca);
    return (false);
  }
  else{
    item->chave = "HEAD";
    item->contador =0;
    (*cabeca)->item = item;
    (*cabeca)->esquerda = *cabeca;
    (*cabeca)->direita = *cabeca;
    return(true);
  }
  }
}

tipo_no*  STprocuraPosicao (tipo_no* cabeca, Chave chave){
  // Procura a posicao na fila que deveria estar o no com a chave especifica
  tipo_no* seek=cabeca;
  do{
    printf ("\n\t%s%d\t", seek->item->chave, seek->item->contador);
    seek = seek->direita;
  } while ((seek != cabeca) && (strcmp (seek->item->chave, chave) < 0));
  return (seek);
}


tipo_no*  STprocuraPosicao (tipo_no* cabeca, Contador contador){
  // Procura a posicao na fila que deveria estar o no com o contador  especifico
  tipo_no* seek = cabeca;
  do{
    printf ("\n\t%s%d\t", seek->item->chave, seek->item->contador);
    seek = seek->direita;
  } while ((seek != cabeca) && (seek->item->contador < contador));
  return (seek);
}

booleano STinserir (tipo_no *cabeca, Item* item){
  // Cria um novo no com valor de item e insere na posicao correta ordenado pela chave
  // Se sucesso => retorna true
  tipo_no *novo, *pos, *no;

  if ((novo = (tipo_no*) malloc (sizeof (tipo_no) )) == NULL)
    return (false);
  else{
    Itematribui (novo->item, item);
    pos  =  STprocuraPosicao (cabeca, item->chave);

    if ( strcmp (pos->item->chave, item->chave) == 0){
      free (novo);
      pos->item->contador++;
    }
    else{
      STinserir (pos->esquerda, novo);
    }
    printf ("\n\t");
    for (no = cabeca->direita; no != cabeca; no = no->direita)
	printf ("%s ->",no->item->chave);
    printf ("%s\n",no->item->chave);
    return(true);
  }
}

void STinserir (tipo_no *anterior, tipo_no *novo){
      novo->esquerda = anterior;
      novo->direita = anterior->direita;
      (anterior->direita)->esquerda = novo;
      anterior->direita = novo;
}

Item* STpop (tipo_no* no){
  Item* temp;
  if (no->esquerda != no){
    no->esquerda->direita = no->direita;
    no->direita->esquerda = no->esquerda;
    Itematribui(temp , no->item);
    free (no);
    return (temp);
  }
  else return(temp);
}

Item* STpopMax (tipo_no* cabeca, Chave chave){
  tipo_no* temp;
  Chave maior= chave;
  do{
    temp = cabeca->direita;
    if (strcmp (temp->item->chave, maior) > 0)
      maior = temp->item->chave;
  } while (temp != cabeca);
  return (STpop(temp));
}

Item* STpopMax (tipo_no* cabeca, Contador contador){
  tipo_no *deletado, *temp=cabeca;
  Contador maior= contador;
  do{
    temp = temp->direita;
    if (temp->item->contador > maior){
      deletado = temp;
      maior = temp->item->contador;
    }
  } while (temp != cabeca);
  return (STpop (deletado));
}
